﻿//2020-05-12: SA:  Start: added script for new pop ups open on Configure2FA screen 
$(document).ready(function () {

    // Event handler for addition of new device (Pairing)
    $(".addDevicefor2FA").click(function () {
        openpairingDialog();
    });
    $(".addDevicefor2FAInLayout").click(function () {
        openpairingDialog();
    });

    $("#smsGalaxkey").click(function () {
        openGalaxkeySMSConfigure();
    });
    
    try {
        if (tw == 1) {
            $("#canBtn1").hide();
            $("#cp2fa1").show();
            $(".addDevicefor2FA1").click();
        }
    } catch (e) {
        // Do nothing
    }

    // Event handler for deleting an existing paired device or mobile
    $('.deletePairing').click(function () {
        var deviceId = $(this).attr("name");
        $.ajax({
            cache: false,
            url: "/Home/RemoveDevicePairing/",
            data: { deviceIdE: deviceId },
            type: 'POST',
            success: function (data) {
                if (data != undefined && data.trim() != '') {
                    window.location.href = data;
                }
                else {
                    var errorMsg = "Unable to delete device now.";
                    var options = {};
                    options['closeButton'] = true;
                    options['positionClass'] = "toast-top-center";
                    options['type'] = "error";
                    var title = "Invalid Operation";
                    toastr[options.type](errorMsg, title, options);
                }
            }
        });
    });

    $("#mobileotpform1").submit(function () {
        var phnNo = $(".PhoneNumberText1").val();
        //var strSelection = $('input[type=radio][name=2FAType]:checked').val();
        //if (strSelection == 'SMS') {
            if ($(this).valid() && validatePhone(phnNo) == true) {
                $('#modalTwoFASMSChoice').modal("hide");
                // Get Selection 

                $.ajax({
                    cache: false,
                    url: "/Home/SendOTPOnPhone/",
                    data: { Phone: phnNo },
                    type: 'POST',
                    success: function (data) {
                        if (data == 'Success') {
                            $("#PhoneNo1").val(phnNo);
                            $('#modalOTP2FA1').modal('show'); // ask for OTP
                        } else {
                            document.open();
                            document.write(data);
                            document.close();
                        }
                        $('#modalTwoFASMSChoice').modal("hide");
                    }
                });
        }
            //else {
            //    var options = {};
            //    options['closeButton'] = true;
            //    options['positionClass'] = "toast-top-right";
            //    options['type'] = "error";
            //    var title = "Compose Error";
            //    toastr[options.type](FormData, title, options);
            //}

        //} else {
        //    // Hide the current dialog
        //    $('#modalTwoFAChoice').modal("hide");
        //    // Show the OTP Dialog
        //    $('#modalTwoFAQR').modal('show');
        //}
        // Since we are just validating, we will return false.
        return false;
    });

    // Event handler for device deletion
    $('.devliceDeleteConfirmationDialog').on('shown.bs.modal', function (e) {
        //get data-id attribute of the clicked element
        var id = $(e.relatedTarget).data('id');
        //populate the label in the confirmation dialog
        $(e.currentTarget).find('.deletePairing').attr("name", id);
    });

    // Event hander for submit when adding a mobile phone number to validate
    $("#mobileotpform").submit(function () {
        var phnNo = $(".PhoneNumberText").val();
        var strSelection = $('input[type=radio][name=2FAType]:checked').val();
        if (strSelection == 'SMS') {
            if ($(this).valid() && validatePhone(phnNo) == true) {
                $('#modalTwoFAChoice').modal("hide");
                // Get Selection 

                $.ajax({
                    cache: false,
                    url: "/Home/SendOTPOnPhone/",
                    data: { Phone: phnNo },
                    type: 'POST',
                    success: function (data) {
                        if (data == 'Success') {
                            $("#PhoneNo").val(phnNo);
                            $('#modalOTP2FA').modal('show'); // ask for OTP
                        } else {
                            document.open();
                            document.write(data);
                            document.close();
                        }
                        $('#modalTwoFAChoice').modal("hide");
                    }
                });
            }
            
        } else {
            // Hide the current dialog
            $('#modalTwoFAChoice').modal("hide");
            // Show the OTP Dialog
            $('#modalTwoFAQR1').modal('show');
        }
        // Since we are just validating, we will return false.
        return false;
    });

    // Event handler when a QR Code dialog is displayed
    $('#modalTwoFAQR1').on('show.bs.modal', function () {
        $.ajax({
            cache: false,
            url: "/Home/RegisterFor2FA/",
            type: 'GET',
            success: function (data) {
                if (data.indexOf("BarcodeImage") == -1) {
                    document.open();
                    document.write(data);
                    document.close();
                }
                else {
                    var divHtmlForQR = "<img src='" + data + "' height='200' width='200'>";
                    $("#twoimgDiv1").html(divHtmlForQR);
                }
            }
        });
    });
    $("#2FAOTPOK1").click(function () {
        $('#modalOTP2FA1').modal("hide");
        var otp = $("#PairingOTP1").val();
        var phoneNo = $("#PhoneNo1").val();
        $.ajax({
            cache: false,
            url: "/Home/ValidateOTPAndPairDevice/",
            data: { OTP: otp, PhoneNo: phoneNo },
            type: 'POST',
            success: function (data) {
                $('#modalOTP2FA1').modal("hide");
                if (data.indexOf("Success2FAOTPPair") != -1) {
                    $('#modalOTP2FAFailure1').modal('hide');
                    $('#modalOTP2FASuccess1').modal('show');
                } else {
                    $('#modalOTP2FAFailure1').modal('show');
                    $('#modalOTP2FASuccess1').modal('hide');
                }

            }
        });


    });

    $('#modalOTP2FA1').on('shown.bs.modal', function (e) {
        $("#PairingOTP1").focus();
    });

    $("#resendOTP1").click(function () {
       
        resendOTPClick1();
        $(this).attr("disabled", "disabled");
        setTimeout(function () {
            $("#resendOTP1").removeAttr("disabled");
            $("#idNextButton").focus();
        }, 30000);
    });

    // Event handler for modal otp 2fa failure
    $('#modalOTP2FAFailure1').on('shown.bs.modal', function (e) {
        $("#2FAOTPFailureOK1").click(function () {
            $('#modalOTP2FAFailure1').modal("hide");
            $('#modalOTP2FA1').modal('show');
        });
    });

    // Event hander for the modal succes dialog
    $('#modalOTP2FASuccess1').on('shown.bs.modal', function (e) {
        $("#2FAOTPSuccessOK1").click(function () {
            window.location.href = '/Home/Index';
            //window.location.reload();
        });
    });

    $("#warnConfigured2FA").click(function () {
        //$('#modalOTP2FA1').modal("hide");
        //var otp = $("#PairingOTP1").val();
        //var phoneNo = $("#PhoneNo1").val();
        //$.ajax({
        //    cache: false,
        //    url: "/Home/ValidateOTPAndPairDevice/",
        //    data: { OTP: otp, PhoneNo: phoneNo },
        //    type: 'POST',
        //    success: function (data) {
        //        $('#modalOTP2FA1').modal("hide");
        //        if (data.indexOf("Success2FAOTPPair") != -1) {
        //            $('#modalOTP2FAFailure1').modal('hide');
        //            $('#modalOTP2FASuccess1').modal('show');
        //        } else {
        //            $('#modalOTP2FAFailure1').modal('show');
        //            $('#modalOTP2FASuccess1').modal('hide');
        //        }

        //    }
        //});
        $('#modalWarnTwoFARemove').modal("show");
        

    });

    $('#modalWarnTwoFARemove').on('shown.bs.modal', function (e) {
        $(".remove2FAandConfigureYotiOK").click(function () {
            var deviceID = document.getElementById('deviceID').value;
            var bIsUrlChange = true;
            
            $.ajax({
                cache: false,
                url: "/Home/RemoveDevicePairing/",
                data: {
                    deviceIdE: deviceID,
                    bIsUrlChange: bIsUrlChange
                },
                type: 'POST',
                success: function (data) {
                    if (data != undefined && data.trim() != '') {
                        window.location.href = data;
                    }
                    else {
                        var errorMsg = "Unable to delete device now.";
                        var options = {};
                        options['closeButton'] = true;
                        options['positionClass'] = "toast-top-center";
                        options['type'] = "error";
                        var title = "Invalid Operation";
                        toastr[options.type](errorMsg, title, options);
                    }
                    
                }
            });
        });
    });
    $("#warnConfiguredYoti").click(function () {
        $('#modalWarnYotiRemove').modal("show");
    });

    $("#warnConfiguredYotiFromSMS").click(function () {
        $('#modalWarnYotiRemove').modal("show");
    });

    $('#modalWarnYotiRemove').on('shown.bs.modal', function (e) {
        $(".removeYotiandConfigure2FAOK").click(function () {
            var twoFAType = document.getElementById('twoFAType').value;
            $.post("/Yoti/Remove",
                {
                    bIsUrlChange: true
                })
                .done(function (data) {
                    if (data != '') {
                        //var obj = jQuery.parseJSON(data);
                        var jSon = JSON.parse([data]);
                        var bResult = Boolean(eval(jSon['result']));
                        if (bResult == true)
                        {
                            var modalWarnYotiRemove = $("#modalWarnYotiRemove");
                            modalWarnYotiRemove.modal('toggle');
                            if (twoFAType == "sms") {
                                openGalaxkeySMSConfigure();
                            }
                            else {
                                $('#modalTwoFAQR1').modal('show'); 
                            }
                        }
                        else {
                            var options = {};
                            options['closeButton'] = true;
                            options['positionClass'] = "toast-top-right";
                            options['type'] = "error";
                            var title = "Internal Error";
                            toastr[options.type]("Something went wrong. Please try again.", title, options);
                            return;
                        }
                    }
                    else {
                        var options1 = {};
                        options1['closeButton'] = true;
                        options1['positionClass'] = "toast-top-right";
                        options1['type'] = "error";
                        var title1 = "Internal Error";
                        toastr[options.type]("Something went wrong. Please try again.", title1, options1);
                        return;
                    }
                });


            //$.ajax({
            //    cache: false,
            //    url: "/Yoti/Remove/",
            //    data: {
            //        bIsUrlChange: true
            //    },
            //    type: 'POST',
            //    success: function (data) {
            //        document.open();
            //        document.write(data);
            //        document.close();
            //    }
            //});
        });
    });
});

// Function to check if the passed value is valid
function isEmpty(val) {
    return (val === undefined || val == null || val.length <= 0) ? true : false;
}

// Function to validate the phone number using regex
function validatePhone(phone) {
    var re = /^\+[0-9]{10,13}$/;
    return re.test(phone);
}

function resendOTPClick1()
{
    var phnNo = $(".PhoneNumberText1").val();
    $.ajax({
        cache: false,
        url: "/Home/SendOTPOnPhone/",
        data: { Phone: phnNo },
        type: 'POST',
        success: function (data) {
            $("#PairingOTP1").focus();

        }
    });
}
