//2020-09-10 PD: ALL THE CHANGES ARE MADE for multisign and multi stamp conf
var signaturePad;
var initialPad;
signaturename = "";
stampname = "";
$(document).ready(function () {
    $(".cancelDefault").click(function () {
        $(this).attr("disabled", "disabled");
        $('<div id="overlay"/>').css({
            position: 'fixed',
            top: 0,
            left: 0,
            width: '100%',
            height: $(window).height() + 'px',
            background: 'white url(/Content/img/galaxkey_whitebk_ani.gif) no-repeat center',
            opacity: 0.90
        }).hide().appendTo('body');

        // SHOW overlay
        $('#overlay').show();
        window.location.reload();

    });
    $("#txtUserSignature").keyup(function () {
        var canvas = document.getElementById('lblSignatureCanvas');
        var context = canvas.getContext('2d');
        context.clearRect(0, 0, canvas.width, canvas.height);

        //set the font styles
        var font = 'Mistral';
        var fontsize = 35;
        //var fontweight = shapes[i].wt;
        //var fontstyle = shapes[i].st;
        context.fillStyle = fontColor;

        // Draw the text
        context.font = fontsize + "px " + font;
        context.textAlign = "center";
        context.textBaseline = "middle";
        context.fillText(document.getElementById('txtUserSignature').value, canvas.width / 2, canvas.height / 2);
    })

    $("#txtUserInitial").keyup(function () {
        var canvas = document.getElementById('lblInitialCanvas');

        var context = canvas.getContext('2d');

        context.clearRect(0, 0, canvas.width, canvas.height);

        //set the font styles
        var font = 'Mistral';
        var fontsize = 35;
        //var fontweight = shapes[i].wt;
        //var fontstyle = shapes[i].st;
        context.fillStyle = initialFontColor;

        // Draw the text
        context.font = fontsize + "px " + font;
        context.textAlign = "center";
        context.textBaseline = "middle";
        context.fillText(document.getElementById('txtUserInitial').value, canvas.width / 2, canvas.height / 2);
    });
    var $datatablesResponsive1 = $('#galaxkey_table1');
    if ($datatablesResponsive1 != undefined) {
        $datatablesResponsive1.DataTable({
            responsive: true,
            "bAutoWidth": false,
            columnDefs: [
                { targets: 'no-sort', orderable: false }
            ],
            order: [[4, "desc"]],
            dom: "<'row'<'col-sm-6 col-sm-push-6'i><'col-sm-6 col-md-pull-6'f>>" + "<'row'<'col-sm-12'tr>>" + "<'row'<'col-sm-6'l><'col-sm-6'p>>",
            language: {
                paginate: {
                    previous: '&laquo;',
                    next: '&raquo;'
                },
                search: "_INPUT_"

            },
            initComplete: function () {
                $('div.dataTables_filter input').attr('autocomplete', 'off')
            }
        });
    }

    var $datatablesResponsive2 = $('#galaxkey_table2');
    if ($datatablesResponsive2 != undefined) {
        $datatablesResponsive2.DataTable({
            responsive: true,
            order: [[3, "desc"]],
            columnDefs: [
                { targets: 'no-sort', orderable: false }
            ],
            dom: "<'row'<'col-sm-6 col-sm-push-6'i><'col-sm-6 col-md-pull-6'f>>" + "<'row'<'col-sm-12'tr>>" + "<'row'<'col-sm-6'l><'col-sm-6'p>>",
            language: {
                paginate: {
                    previous: '&laquo;',
                    next: '&raquo;'
                },
                search: "_INPUT_"

            },
            initComplete: function () {
                $('div.dataTables_filter input').attr('autocomplete', 'off')
            }
        });
    }
    // Setup signature pad.
    var wrapper = document.getElementById("signature-pad");
    if (wrapper != null) {
        var clearButton = wrapper.querySelector("[data-action=clear]");

        var changeColorButton = wrapper.querySelector("[data-action=change-color]");

        var undoButton = wrapper.querySelector("[data-action=undo]");

        //var saveJPGButton = wrapper.querySelector("[data-action=save-jpg]");

        //var saveSVGButton = wrapper.querySelector("[data-action=save-svg]");

        var canvas = wrapper.querySelector("canvas");


        signaturePad = new SignaturePad(canvas, {
            // It's Necessary to use an opaque color when saving image as JPEG;
            // this option can be omitted if only saving as PNG or SVGsave
            backgroundColor: 'rgb(255, 255, 255)'
        });
        // Signature pad clear button event.
        clearButton.addEventListener("click", function (event) {
            signaturePad.clear();
        });

        // Signature pad undo button event.
        undoButton.addEventListener("click", function (event) {
            var data = signaturePad.toData();

            if (data) {
                data.pop(); // remove the last dot or line
                signaturePad.fromDataRedraw(data, signaturePad.penColor);//2022-0822 PD: #6407
            }
        });
    }



    // Setup initial pad.
    var initialPadWrapper = document.getElementById("initial-pad");
    if (initialPadWrapper != null) {
        var initialPadClearButton = initialPadWrapper.querySelector("[data-action=clear]");

        var initialPadUndoButton = initialPadWrapper.querySelector("[data-action=undo]");

        var initialCanvas = initialPadWrapper.querySelector("canvas");

        initialPad = new SignaturePad(initialCanvas, {
            // It's Necessary to use an opaque color when saving image as JPEG;
            // this option can be omitted if only saving as PNG or SVGsave
            backgroundColor: 'rgb(255, 255, 255)'
        });

        // Initial pad clear button event.
        initialPadClearButton.addEventListener("click", function (event) {
            initialPad.clear();
        });

        // Initial pad undo button event.
        initialPadUndoButton.addEventListener("click", function (event) {
            var data = initialPad.toData();

            if (data) {
                data.pop(); // remove the last dot or line
                initialPad.fromDataRedraw(data, initialPad.penColor);//2022-0822 PD: #6407
            }
        });
    }


    $(".chkmaxlength").on("keyup", function () {
        var maxLength = $(this).attr("maxlength");
        if (maxLength > $(this).val().length) {

            $(this).attr('data-show', "true");
        }

        if ($(this).attr('data-show') != 'false') {

            if (maxLength == $(this).val().length) {
                showAlert("Maximum " + maxLength + " characters are allowed")
                $(this).attr('data-show', "false");
            }
        }



    })

});



function savePfx() {
    var pfxPwd = document.getElementById('txtPfxPassword').value;
    var pfxConfirmPwd = document.getElementById('txtPfxConfirmPassword').value;


    if (pfxPwd == '') {
        showAlert('Password is required.');
        document.getElementById('txtPfxPassword').focus();
        return;
    }
    if (pfxPwd != pfxConfirmPwd) {
        showAlert('Password and Confirm Password does not match.');
        document.getElementById('txtPfxPassword').focus();
        return;
    }
    // Check user weather user has signature and initial enter or not.
    if (pfxAttachedData == null || pfxAttachedData == undefined) {
        showAlert('Pfx file is required.');
        return;
    }

    // Create overlay and append to body:
    $('<div id="overlay"/>').css({
        position: 'fixed',
        top: 0,
        left: 0,
        width: '100%',
        height: $(window).height() + 'px',
        background: 'white url(/Content/img/galaxkey_whitebk_ani.gif) no-repeat center',
        opacity: 0.90
    }).hide().appendTo('body');

    // SHOW overlay
    $('#overlay').show();

    $.ajax({
        //?' + $.param({ paramInQuery: 1 })  + $.param({ paramInQuery: 1 }
        url: "/SecureSign/UploadPfxDetails?" + $.param({ pfxPwd: pfxPwd }),
        type: "POST",
        data: pfxAttachedData,
        contentType: false,
        processData: false,
        success: function (result) {
            $('#overlay').hide();
            document.getElementById('txtPfxPassword').value = '';
            var options = {};
            options['closeButton'] = true;
            options['positionClass'] = "toast-top-center";
            var title = "";
            options['type'] = "success";
            toastr[options.type]('The pfx file and password are saved successfully.', title, options);
        },
        error: function (jqXHR, status, err) {

            // Show loader on every add signatory.
            $('#loaderForSelectDocument').hide();
            $('#overlay').hide();
            $("#btnNextPrev").removeAttr("disabled");
            showAlert('Unable to upload selected document.');
        }

    });
}
//2020 - 06 - 01: SA: End: Add function to save pfx file and signature into folder


// Adjust canvas coordinate space taking into account pixel ratio,
// to make it look crisp on mobile devices.
// This also causes canvas to be cleared.
function resizeCanvas() {
    // When zoomed out to less than 100%, for some very strange reason,
    // some browsers report devicePixelRatio as less than 1
    // and only part of the canvas is cleared then.
    var ratio = Math.max(window.devicePixelRatio || 1, 1);

    // This part causes the canvas to be cleared
    canvas.width = canvas.offsetWidth * ratio;
    canvas.height = canvas.offsetHeight * ratio;
    canvas.getContext("2d").scale(ratio, ratio);

    // This library does not listen for canvas changes, so after the canvas is automatically
    // cleared by the browser, SignaturePad#isEmpty might still return false, even though the
    // canvas looks empty, because the internal data of this library wasn't cleared. To make sure
    // that the state of this library is consistent with visual state of the canvas, you
    // have to clear it manually.
    signaturePad.clear();
}

// On mobile devices it might make more sense to listen to orientation change,
// rather than window resize events.
//window.onresize = resizeCanvas;
//resizeCanvas();

function download(dataURL, filename) {
    var blob = dataURLToBlob(dataURL);

    var url = window.URL.createObjectURL(blob);

    var a = document.createElement("a");
    a.style = "display: none";
    a.href = url;
    a.download = filename;

    document.body.appendChild(a);
    // a.click();

    window.URL.revokeObjectURL(url);
}

// One could simply use Canvas#toBlob method instead, but it's just to show
// that it can be done using result of SignaturePad#toDataURL.
function dataURLToBlob(dataURL) {
    // Code taken from https://github.com/ebidel/filer.js
    var parts = dataURL.split(';base64,');
    var contentType = parts[0].split(":")[1];
    var raw = window.atob(parts[1]);
    var rawLength = raw.length;
    var uInt8Array = new Uint8Array(rawLength);

    for (var i = 0; i < rawLength; ++i) {
        uInt8Array[i] = raw.charCodeAt(i);
    }

    return new Blob([uInt8Array], { type: contentType });
}





$("#btnDrawSignInitialOld").click(function () {

    // Check signature pad and initial pad empty or not.


    var dataURL = signaturePad.toDataURL();
    var base64strForSign = dataURL.split('base64,');

    dataURL = initialPad.toDataURL();
    var base64strForInitial = dataURL.split('base64,');

    if (validatePad() == false) {
        return;
    }

    // Create overlay and append to body:
    $('<div id="overlay"/>').css({
        position: 'fixed',
        top: 0,
        left: 0,
        width: '100%',
        height: $(window).height() + 'px',
        background: 'white url(/Content/img/galaxkey_whitebk_ani.gif) no-repeat center',
        opacity: 0.90
    }).hide().appendTo('body');

    // SHOW overlay
    $('#overlay').show();
    wholedata = JSON.stringify({
        'signatures': [base64strForSign[1], base64strForInitial[1]],
        'signMethod': 'Draw'
    });

    $.ajax({
        type: 'POST',
        url: '/SecureSign/SaveSignatures',
        data: wholedata,
        contentType: 'application/json; charset=utf-8',

        success: function (data) {
            if (data.indexOf('Error') == 0) {
                $('#overlay').hide();
                var strErr = data.split('Error');

                showAlert(strErr[1]);
            }
            //document.open();
            //document.write(data);
            //document.close();
            window.location.href = data;
        },
        //call on ajax call failure
        error: function (xhr, textStatus, error) {
            $('#overlay').hide();
        }
    });
});

$("#btnDrawSignInitial").click(function () {

    // Check signature pad and initial pad empty or not.


    var dataURL = signaturePad.toDataURL();
    var base64strForSign = dataURL.split('base64,');

    dataURL = initialPad.toDataURL();
    var base64strForInitial = dataURL.split('base64,');
    var purpose = $("#txtSignPurpose").val();
    var name = $("#txtSignName").val();
    var isDefault = $("#isDefault").val();
    if (name == "" || name == undefined || name == null) {
        showAlert('Name is required.');
        return;
    }
    if (purpose == "" || purpose == undefined || purpose == null) {
        showAlert('Purpose is required.');
        return;
    }

    if (validatePad() == false) {
        return;
    }

    // Create overlay and append to body:
    $('<div id="overlay"/>').css({
        position: 'fixed',
        top: 0,
        left: 0,
        width: '100%',
        height: $(window).height() + 'px',
        background: 'white url(/Content/img/galaxkey_whitebk_ani.gif) no-repeat center',
        opacity: 0.90
    }).hide().appendTo('body');

    // SHOW overlay
    $('#overlay').show();
    wholedata = JSON.stringify({
        'lstSignatures': [base64strForSign[1], base64strForInitial[1]],
        'strSignmethod': 'Drawn',
        'strPurpose': purpose,
        'strName': name,
        'bIsDefault': isDefault
    });

    $.ajax({
        type: 'POST',
        url: '/SecureSign/SaveSignaturesForMultipleSigns',
        data: wholedata,
        contentType: 'application/json; charset=utf-8',

        success: function (data) {
            if (data.indexOf('Error') == 0) {
                $('#overlay').hide();
                var strErr = data.split('Error');

                showAlert(strErr[1]);
            } else {
                //document.open();
                //document.write(data);
                //document.close();
                window.location.href = data;
            }
        },
        //call on ajax call failure
        error: function (xhr, textStatus, error) {
            $('#overlay').hide();
        }
    });
});

function validatePad() {
    if (signaturePad.isEmpty()) {
        showAlert('Signature is required.');
        return false;
    }

    if (initialPad.isEmpty()) {
        showAlert('Initial is required.');
        return false;
    }
}

var fontText = 'Arial';
var fontSize = 16;
var fontWieght = "";
var fontStyle = "";
var fontColor = "black";
var initialFontColor = "black";
var colorSetForSignature = false;
var underline = "";
var initialUnderline = "";
var text = $('#textareaTest').val();

function ddFontChange(isFromSignature) {
    var dFont = document.getElementById(isFromSignature ? 'ddFont' : 'initialFont');
    fontText = dFont.options[dFont.selectedIndex].value;

    $(isFromSignature ? '#textareaTest' : '#textareaTestForInitial').css('font-family', fontText);
}

function ddSizeChange(isFromSignature) {
    var dSize = document.getElementById(isFromSignature ? 'ddSize' : 'initialSize');
    fontSize = dSize.options[dSize.selectedIndex].value;

    $(isFromSignature ? '#textareaTest' : '#textareaTestForInitial').css('font-size', fontSize + "px");
}

function makeBold(isFromSignature) {

    if ($(isFromSignature ? '#btnBold' : '#btnBoldForInitial').hasClass('active1')) {
        $(isFromSignature ? '#textareaTest' : '#textareaTestForInitial').css('font-weight', 'bold');
        fontWieght = "bold";
    }
    else {
        $(isFromSignature ? '#textareaTest' : '#textareaTestForInitial').css('font-weight', 'normal');
        fontWieght = "normal";
    }
}

function goBack() {
    window.history.back();
}

// This method invoke while clicking edit button
function editSign() {
    // Hide sinature preview.
    $('#divPreviewSignature').hide();

    // Show signature methof option.
    $('#divSignMethod').show();
    $("#HideOnSignatureCreation").hide();
    $("#ShowOnSignatureCreation").show();
    // Trigger user signature textbox keyup event to set default preview of the signature
    $('#txtUserSignature').trigger(
        jQuery.Event('keyup', {})
    );

    // Trigger user initial textbox keyup event to set default preview of the initial
    $('#txtUserInitial').trigger(
        jQuery.Event('keyup', {})
    );

    // Signature container
    $('#container').show();
}

$(".btn").click(function () {

    if ($(this).hasClass("active1")) {
        $(this).removeClass("active1");
    } else {
        $(this).addClass("active1");
    }

    makeItalic(this.id == 'btnItalic' ? true : false);
    makeUnderline(this.id == 'btnUnderline' ? true : false);
    makeBold(this.id == 'btnBold' ? true : false);
});

function makeItalic(isFromSignature) {

    if ($(isFromSignature ? '#btnItalic' : '#btnItalicForInitial').hasClass('active1')) {

        $(isFromSignature ? '#textareaTest' : '#textareaTestForInitial').css('font-style', 'italic');
        fontStyle = "italic";
    }
    else {
        $(isFromSignature ? '#textareaTest' : '#textareaTestForInitial').css('font-style', '');
        fontStyle = "";
    }
}

function makeUnderline(isFromSignature) {
    if ($(isFromSignature ? '#btnUnderline' : '#btnUnderlineForInitial').hasClass('active1')) {

        $(isFromSignature ? '#textareaTest' : '#textareaTestForInitial').css('text-decoration', 'Underline');

        if (isFromSignature)
            underline = "Underline";
        else
            initialUnderline = "Underline";
    }
    else {
        $(isFromSignature ? '#textareaTest' : '#textareaTestForInitial').css('text-decoration', '');
        if (isFromSignature)
            underline = "";
        else
            initialUnderline = "";
    }
}

function showColorDialog(isCallFromSignature) {
    colorSetForSignature = isCallFromSignature ? true : false;
    $('#myColors').modal('show');
}

function selectColor(color_this) {

    $(colorSetForSignature ? '#textareaTest' : '#textareaTestForInitial').css('color', color_this.name);
    $(colorSetForSignature ? '#btnColor' : '#btnColorForInitial').css('background-color', color_this.name);

    if (colorSetForSignature)
        fontColor = color_this.name;
    else
        initialFontColor = color_this.name;

    $('#myColors').modal('hide');
}
//2021-05-25: PD: #3024
function saveUploadedStamps() {

    var bstampUrl = true;
    // Create overlay and append to body:
    $('<div id="overlay"/>').css({
        position: 'fixed',
        top: 0,
        left: 0,
        width: '100%',
        height: $(window).height() + 'px',
        background: 'white url(/Content/img/galaxkey_whitebk_ani.gif) no-repeat center',
        opacity: 0.90
    }).hide().appendTo('body');

    var purpose = $("#txtStampPurpose").val();
    var name = $("#txtStampName").val();
    var isDefault = $("#isDefault").val();
    if (name == "" || name == undefined || name == null) {
        showAlert('Name is required.');
        return;
    }
    if (purpose == "" || purpose == undefined || purpose == null) {
        showAlert('Purpose is required.');
        return;
    }
    if (stampUrl == '' || stampUrl == null || stampUrl == undefined) {
        showAlert('Stamp is required.');
        bstampUrl = false;
        return false;
    }


    //var dataURL = lblSignatureCanvas.toDataURL();


    //dataURL = lblInitialCanvas.toDataURL();


    var base64strForSign = stampUrl.split('base64,');
    // SHOW overlay
    $('#overlay').show();
    wholedata = JSON.stringify({
        'sStampData': base64strForSign[1],
        'sPurpose': purpose,
        'sStampName': name,
        'bIsDefault': isDefault
    });
    var data = new FormData();

    data.append("sStampData", base64strForSign[1]);
    data.append("sPurpose", purpose);
    data.append("sStampName", name);
    data.append("bIsDefault", isDefault);

    $.ajax({
        type: 'POST',
        url: '/SecureSign/SaveStamp',
        data: data,
        contentType: false,
        processData: false,
        success: function (data) {

            if (data.indexOf('Error') == 0) {
                $('#overlay').hide();
                var strErr = data.split('Error');

                showAlert(strErr[1]);

            } else {
                window.location.href = data;
            }
        },
        //call on ajax call failure
        error: function (xhr, textStatus, error) {
            $('#overlay').hide();
        }
    });

}

//2021-05-25: PD: #3024
function saveUploadedSignatures() {
    var binitUrl = true;
    var bsignatureUrl = true;


    // Create overlay and append to body:
    $('<div id="overlay"/>').css({
        position: 'fixed',
        top: 0,
        left: 0,
        width: '100%',
        height: $(window).height() + 'px',
        background: 'white url(/Content/img/galaxkey_whitebk_ani.gif) no-repeat center',
        opacity: 0.90
    }).hide().appendTo('body');
    var purpose = $("#txtSignPurpose").val();
    var name = $("#txtSignName").val();
    var isDefault = $("#isDefault").val();
    if (name == "" || name == undefined || name == null) {
        showAlert('Name is required.');
        return;
    }
    if (purpose == "" || purpose == undefined || purpose == null) {
        showAlert('Purpose is required.');
        return;
    }

    if (initUrl == '' || initUrl == null || initUrl == undefined) {
        showAlert('Initial is required.');
        binitUrl = false;
        return false;
    }
    if (signatureUrl == '' || signatureUrl == null || signatureUrl == undefined) {
        showAlert('Signature is required.');
        bsignatureUrl = false;
        return false;
    }

    //var dataURL = lblSignatureCanvas.toDataURL();
    var base64strForSign = signatureUrl.split('base64,');

    //dataURL = lblInitialCanvas.toDataURL();
    var base64strForInitial = initUrl.split('base64,');
    // SHOW overlay
    $('#overlay').show();
    var lstSignatures = [base64strForSign[1], base64strForInitial[1]];
    wholedata = JSON.stringify({
        'lstSignatures': [base64strForSign[1], base64strForInitial[1]],
        'strSignmethod': 'Uploaded',
        'strPurpose': purpose,
        'strName': name,
        'bIsDefault': isDefault
    });
    var data = new FormData();

    data.append("lstSignatures[]", base64strForSign[1]);
    data.append("lstSignatures[]", base64strForInitial[1]);
    data.append("strSignmethod", 'Uploaded');
    data.append("strPurpose", purpose);
    data.append("strName", name);
    data.append("bIsDefault", isDefault);


    $.ajax({
        type: 'POST',
        url: '/SecureSign/SaveSignaturesForMultipleSigns',
        data: data,
        contentType: false,
        processData: false,
        success: function (data) {
            if (data.indexOf('Error') == 0) {
                $('#overlay').hide();
                var strErr = data.split('Error');

                showAlert(strErr[1].replace(":", ""));

            } else {
                window.location.href = data;
            }
        },
        //call on ajax call failure
        error: function (xhr, textStatus, error) {
            $('#overlay').hide();
        }
    });

}


function saveTextFromAreaOld() {

    var lblSignatureCanvas = document.getElementById('lblSignatureCanvas');
    var lblInitialCanvas = document.getElementById('lblInitialCanvas');

    // Check user weather user has signature and initial enter or not.






    var dataURL = lblSignatureCanvas.toDataURL();
    var base64strForSign = dataURL.split('base64,');

    dataURL = lblInitialCanvas.toDataURL();
    var base64strForInitial = dataURL.split('base64,');

    if (document.getElementById('txtUserSignature').value == '') {
        showAlert('Signature is required.');
        document.getElementById('txtUserSignature').focus();
        return;
    } else if (document.getElementById('txtUserInitial').value == '') {
        showAlert('Initial is required.');
        document.getElementById('txtUserInitial').focus();
        return;
    }
    // Create overlay and append to body:
    $('<div id="overlay"/>').css({
        position: 'fixed',
        top: 0,
        left: 0,
        width: '100%',
        height: $(window).height() + 'px',
        background: 'white url(/Content/img/galaxkey_whitebk_ani.gif) no-repeat center',
        opacity: 0.90
    }).hide().appendTo('body');

    // SHOW overlay
    $('#overlay').show();
    var isDefault = $("#isDefault").val();
    wholedata = JSON.stringify({
        'signatures': [base64strForSign[1], base64strForInitial[1]],
        'signMethod': 'Generated'
    });
    $.ajax({
        type: 'POST',
        url: '/SecureSign/SaveSignatures',
        data: wholedata,
        contentType: 'application/json; charset=utf-8',

        success: function (data) {
            if (data.indexOf('Error') == 0) {
                $('#overlay').hide();
                var strErr = data.split('Error');

                showAlert(strErr[1]);
            } else {
                window.location.href = data;
            }
        },
        //call on ajax call failure
        error: function (xhr, textStatus, error) {
            $('#overlay').hide();
        }
    });

}

function saveTextFromArea() {

    var lblSignatureCanvas = document.getElementById('lblSignatureCanvas');
    var lblInitialCanvas = document.getElementById('lblInitialCanvas');

    // Check user weather user has signature and initial enter or not.






    var dataURL = lblSignatureCanvas.toDataURL();
    var base64strForSign = dataURL.split('base64,');

    dataURL = lblInitialCanvas.toDataURL();
    var base64strForInitial = dataURL.split('base64,');
    var purpose = $("#txtSignPurpose").val();
    var name = $("#txtSignName").val();
    if (name == "" || name == undefined || name == null) {
        showAlert('Name is required.');
        return;
    }
    if (purpose == "" || purpose == undefined || purpose == null) {
        showAlert('Purpose is required.');
        return;
    }
    if (document.getElementById('txtUserSignature').value == '') {
        showAlert('Signature is required.');
        document.getElementById('txtUserSignature').focus();
        return;
    } else if (document.getElementById('txtUserInitial').value == '') {
        showAlert('Initial is required.');
        document.getElementById('txtUserInitial').focus();
        return;
    }
    // Create overlay and append to body:
    $('<div id="overlay"/>').css({
        position: 'fixed',
        top: 0,
        left: 0,
        width: '100%',
        height: $(window).height() + 'px',
        background: 'white url(/Content/img/galaxkey_whitebk_ani.gif) no-repeat center',
        opacity: 0.90
    }).hide().appendTo('body');

    // SHOW overlay
    $('#overlay').show();
    var isDefault = $("#isDefault").val();
    wholedata = JSON.stringify({
        'lstSignatures': [base64strForSign[1], base64strForInitial[1]],
        'strSignmethod': 'Generated',
        'strPurpose': purpose,
        'strName': name,
        'bIsDefault': isDefault

    });
    $.ajax({
        type: 'POST',
        url: '/SecureSign/SaveSignaturesForMultipleSigns',
        data: wholedata,
        contentType: 'application/json; charset=utf-8',

        success: function (data) {
            if (data.indexOf('Error') == 0) {
                $('#overlay').hide();
                var strErr = data.split('Error');

                showAlert(strErr[1]);
            } else {
                window.location.href = data;
            }
        },
        //call on ajax call failure
        error: function (xhr, textStatus, error) {
            $('#overlay').hide();
        }
    });

}

function showAlert(message) {

    var options = {};
    options['closeButton'] = true;
    options['positionClass'] = "toast-top-center";
    var title = "";
    options['type'] = "error";
    toastr[options.type](message, title, options);
}

$(".btnDiscardConfigSign").click(function () {
    $('#modalCancelConfigureSign').hide();
    window.location.href = $("#cancelUrl").val();
});




$(".defaultSignChk").click(function () {
    signaturename = $(this).attr("name");

    if ($(this).is(':checked')) {
        $("#modalForMakingDefaultSign").modal('show');

    } else {
        $("#modalForRemovingDefaultSign").modal('show');
    }

});

$('#makedefaultsign').click(function () {
    $("#modalForMakingDefaultSign").modal('hide');
    // SHOW overlay    
    setDefaultForSignature(true, "makedefaultsign")

});

$('#removedefault').click(function () {
    $("#modalForRemovingDefaultSign").modal('hide');
    // SHOW overlay    
    setDefaultForSignature(false, "removedefault")

});

function setDefaultForSignature(isdefault, dialogname) {

    showOverlay();
    var signname = $("#" + dialogname).attr("name");
    $.ajax({
        cache: false,
        url: "/SecureSign/ChangeDefaultOfSignature",
        data: { signname: signname, isdefault: isdefault },
        type: 'POST',
        success: function (data) {
            window.location.href = data;
        },
        error: function (jqXHR, status, err) {
            hideOverlay();
            showAlert('Unable to set the default.');
        }
    });
}

$('#modalForMakingDefaultSign').on('shown.bs.modal', function (e) {

    //alert(id);
    //populate the label in the confirmation dialog
    $(this).find('#makedefaultsign').attr("name", signaturename);

});

$('#modalForRemovingDefaultSign').on('shown.bs.modal', function (e) {
    //get data-id attribute of the clicked element
    //var id = $(e.relatedTarget).data('id');
    //alert(id);
    //populate the label in the confirmation dialog
    $(this).find('#removedefault').attr("name", signaturename);

});


$(".defaultStampChk").click(function () {
    stampname = $(this).attr("name");

    if ($(this).is(':checked')) {
        $("#modalForMakingDefaultStamp").modal('show');

    } else {
        $("#modalForRemovingDefaultStamp").modal('show');
    }

});

$('#makedefaultstamp').click(function () {
    $("#modalForMakingDefaultStamp").modal('hide');
    // SHOW overlay    
    setDefaultForStamp(true, "makedefaultstamp")

});

$('#removedefaultstamp').click(function () {
    $("#modalForRemovingDefaultStamp").modal('hide');
    // SHOW overlay    
    setDefaultForStamp(false, "removedefaultstamp")

});

function setDefaultForStamp(isdefault, dialogname) {

    showOverlay();
    var stampname = $("#" + dialogname).attr("name");
    $.ajax({
        cache: false,
        url: "/SecureSign/ChangeDefaultOfStamp",
        data: { stampname: stampname, isdefault: isdefault },
        type: 'POST',
        success: function (data) {
            window.location.href = data;
        },
        error: function (jqXHR, status, err) {
            hideOverlay();
            showAlert('Unable to set the default.');
        }
    });
}

$('#modalForMakingDefaultStamp').on('shown.bs.modal', function (e) {

    //alert(id);
    //populate the label in the confirmation dialog
    $(this).find('#makedefaultstamp').attr("name", stampname);

});

$('#modalForRemovingDefaultStamp').on('shown.bs.modal', function (e) {
    //get data-id attribute of the clicked element
    //var id = $(e.relatedTarget).data('id');
    //alert(id);
    //populate the label in the confirmation dialog
    $(this).find('#removedefaultstamp').attr("name", stampname);

});
$('.deletesign').click(function () {
    $(".signDeleteConfirmationDialog").modal('hide');
    // SHOW overlay
    showOverlay();
    var signname = $(this).attr("name");
    $.ajax({
        cache: false,
        url: "/SecureSign/DeleteSignature",
        data: { signname: signname },
        type: 'POST',
        success: function (data) {
            window.location.href = data;
        },
        error: function (jqXHR, status, err) {
            showAlert('Unable to remove signature.');
            hideOverlay();
        }
    });
});
$('.deletestamp').click(function () {
    $(".stampDeleteConfirmationDialog").modal('hide');
    // SHOW overlay
    showOverlay();
    var stampname = $(this).attr("name");
    $.ajax({
        cache: false,
        url: "/SecureSign/DeleteStamp",
        data: { stampname: stampname },
        type: 'POST',
        success: function (data) {
            window.location.href = data;
        },
        error: function (jqXHR, status, err) {
            showAlert('Unable to remove stamp.');
            hideOverlay();
        }
    });
});
$('.signDeleteConfirmationDialog').on('shown.bs.modal', function (e) {
    //get data-id attribute of the clicked element
    var id = $(e.relatedTarget).data('id');
    //populate the label in the confirmation dialog
    $(e.currentTarget).find('.deletesign').attr("name", id);
});
$('.stampDeleteConfirmationDialog').on('shown.bs.modal', function (e) {
    //get data-id attribute of the clicked element
    var id = $(e.relatedTarget).data('id');
    //populate the label in the confirmation dialog
    $(e.currentTarget).find('.deletestamp').attr("name", id);
});

function showOverlay() {
    if (document.getElementById("overlay") == null || document.getElementById("overlay") == undefined) {
        // Create overlay and append to body:
        $('<div id="overlay"/>').css({
            position: 'fixed',
            top: 0,
            left: 0,
            width: '100%',
            height: $(window).height() + 'px',
            background: 'white url(/Content/img/galaxkey_whitebk_ani.gif) no-repeat center',
            opacity: 0.90
        }).hide().appendTo('body');
    }

    // SHOW overlay
    $('#overlay').show();
}

function hideOverlay() {
    if (document.getElementById("overlay") != null || document.getElementById("overlay") != undefined) {
        $('#overlay').hide();
    }
}
//2022-0822 PD: #6289
$(".signColorCls").click(function () {
    $(".signColorCls").removeClass("colorSelected");
    $(this).addClass("colorSelected");    
    signaturePad.penColor = $(this).attr("data-color");
    var data = signaturePad.toData();

    if (data) {
        signaturePad.clear();
        signaturePad.fromDataRedraw(data, $(this).attr("data-color"));
    }
})


$(".initialColorCls").click(function () {
    $(".initialColorCls").removeClass("colorSelected");
    $(this).addClass("colorSelected");
    initialPad.penColor = $(this).attr("data-color");
    var data = initialPad.toData();

    if (data) {
        initialPad.clear();
        initialPad.fromDataRedraw(data, $(this).attr("data-color"));
    }
})
//2022-0822 PD: #6289